"""Local File System product"""
__doc__="""Local File System product"""

from ZPublisher.Iterators import filestream_iterator
from OFS.Image import File
from webdav.common import rfc1123_date

class StreamingFile(File):
    """ wrapper around OFS.Image.File that does streaming from the file"""
    def index_html(self, REQUEST, RESPONSE):
	""" Return file stream with range support """
	# DM 2005-11-18: support for 'if_modified_since' and range requests
	if self._if_modified_since_request_handler(REQUEST, RESPONSE):
	    # we were able to handle this by returning a 304
	    return ''
	if self._range_request_handler(REQUEST, RESPONSE):
	    # we served a chunk of content in response to a range request.
	    return ''
        RESPONSE.setHeader('Content-Type', self.content_type)
        RESPONSE.setHeader('Content-Length', self.size)
	RESPONSE.setHeader('Last-Modified', rfc1123_date(self._p_mtime))
        RESPONSE.setHeader('Accept-Ranges', 'bytes')
	#~ threshold = 2 << 16 # 128 kb
	#~ if self.size < threshold:
	    #~ try:
		#~ f = open(self._local_path, 'rb')
		#~ return f.read()
	    #~ finally:
		#~ f.close()
	return filestream_iterator(self._local_path, 'rb')
